(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_f_#in~y| () Int)
(declare-fun |honda_f_#in~y| () Int)
(declare-fun |ray_f_#in~y| () Int)
(declare-fun |init_f_#t~mem12| () Int)
(declare-fun |honda_f_#t~mem12| () Int)
(declare-fun |ray_f_#t~mem12| () Int)
(declare-fun init_f_~c~2.base () Int)
(declare-fun honda_f_~c~2.base () Int)
(declare-fun ray_f_~c~2.base () Int)
(declare-fun |init_f_#t~malloc0.offset| () Int)
(declare-fun |honda_f_#t~malloc0.offset| () Int)
(declare-fun |ray_f_#t~malloc0.offset| () Int)
(declare-fun init_f_~y_ref~2.base () Int)
(declare-fun honda_f_~y_ref~2.base () Int)
(declare-fun ray_f_~y_ref~2.base () Int)
(declare-fun |init_f_#t~malloc0.base| () Int)
(declare-fun |honda_f_#t~malloc0.base| () Int)
(declare-fun |ray_f_#t~malloc0.base| () Int)
(declare-fun |init_f_#in~x| () Int)
(declare-fun |honda_f_#in~x| () Int)
(declare-fun |ray_f_#in~x| () Int)
(declare-fun |init_f_#t~mem10| () Int)
(declare-fun |honda_f_#t~mem10| () Int)
(declare-fun |ray_f_#t~mem10| () Int)
(declare-fun |init_f_#t~malloc3.offset| () Int)
(declare-fun |honda_f_#t~malloc3.offset| () Int)
(declare-fun |ray_f_#t~malloc3.offset| () Int)
(declare-fun |init_f_#t~malloc3.base| () Int)
(declare-fun |honda_f_#t~malloc3.base| () Int)
(declare-fun |ray_f_#t~malloc3.base| () Int)
(declare-fun init_f_~y_ref~2.offset () Int)
(declare-fun honda_f_~y_ref~2.offset () Int)
(declare-fun ray_f_~y_ref~2.offset () Int)
(declare-fun |init_f_#t~malloc2.offset| () Int)
(declare-fun |honda_f_#t~malloc2.offset| () Int)
(declare-fun |ray_f_#t~malloc2.offset| () Int)
(declare-fun init_f_~flag~2.offset () Int)
(declare-fun honda_f_~flag~2.offset () Int)
(declare-fun ray_f_~flag~2.offset () Int)
(declare-fun init_f_~x_ref~2.base () Int)
(declare-fun honda_f_~x_ref~2.base () Int)
(declare-fun ray_f_~x_ref~2.base () Int)
(declare-fun init_f_~flag~2.base () Int)
(declare-fun honda_f_~flag~2.base () Int)
(declare-fun ray_f_~flag~2.base () Int)
(declare-fun init_f_~y () Int)
(declare-fun honda_f_~y () Int)
(declare-fun ray_f_~y () Int)
(declare-fun |init_f_#t~malloc2.base| () Int)
(declare-fun |honda_f_#t~malloc2.base| () Int)
(declare-fun |ray_f_#t~malloc2.base| () Int)
(declare-fun init_f_~x () Int)
(declare-fun honda_f_~x () Int)
(declare-fun ray_f_~x () Int)
(declare-fun |init_f_#t~mem14| () Int)
(declare-fun |honda_f_#t~mem14| () Int)
(declare-fun |ray_f_#t~mem14| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_f_#t~post9| () Int)
(declare-fun |honda_f_#t~post9| () Int)
(declare-fun |ray_f_#t~post9| () Int)
(declare-fun init_f_~x_ref~2.offset () Int)
(declare-fun honda_f_~x_ref~2.offset () Int)
(declare-fun ray_f_~x_ref~2.offset () Int)
(declare-fun |init_f_#t~malloc1.base| () Int)
(declare-fun |honda_f_#t~malloc1.base| () Int)
(declare-fun |ray_f_#t~malloc1.base| () Int)
(declare-fun init_f_~c~2.offset () Int)
(declare-fun honda_f_~c~2.offset () Int)
(declare-fun ray_f_~c~2.offset () Int)
(declare-fun |init_f_#t~malloc1.offset| () Int)
(declare-fun |honda_f_#t~malloc1.offset| () Int)
(declare-fun |ray_f_#t~malloc1.offset| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |init_f_#t~mem8| () Int)
(declare-fun |honda_f_#t~mem8| () Int)
(declare-fun |ray_f_#t~mem8| () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length f_~flag~2.base)| () Int)
(declare-fun |ray_(select #length f_~flag~2.base)| () Int)
(declare-fun |honda_(ite (select #valid f_~c~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid f_~c~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length f_~y_ref~2.base)| () Int)
(declare-fun |ray_(select #length f_~y_ref~2.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| () Int)
(declare-fun |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)| ()
  Int)
(declare-fun |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length f_~c~2.base)| () Int)
(declare-fun |ray_(select #length f_~c~2.base)| () Int)
(declare-fun |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| ()
  Int)
(declare-fun |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| () Int)
(declare-fun |honda_(select old(#length) f_~y_ref~2.base)| () Int)
(declare-fun |ray_(select old(#length) f_~y_ref~2.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |honda_(select #length f_~x_ref~2.base)| () Int)
(declare-fun |ray_(select #length f_~x_ref~2.base)| () Int)
(declare-fun |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| () Int)
(declare-fun |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
  () Int)
(declare-fun |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| ()
  Int)
(declare-fun |honda_(select old(#length) f_~x_ref~2.base)| () Int)
(declare-fun |ray_(select old(#length) f_~x_ref~2.base)| () Int)
(declare-fun |honda_(select old(#length) f_~flag~2.base)| () Int)
(declare-fun |ray_(select old(#length) f_~flag~2.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
  () Int)
(declare-fun |honda_(ite (select #valid f_~flag~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid f_~flag~2.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) f_~c~2.base)| () Int)
(declare-fun |ray_(select old(#length) f_~c~2.base)| () Int)
(declare-fun lambda () Int)
(assert
 (and
 (or
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base (- 1))
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 1) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_f_#t~mem12| |honda_f_#t~mem12|)
 (= |init_f_#t~mem10| |honda_f_#t~mem10|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~post9| |honda_f_#t~post9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| (- 1)) 
 (* |honda_f_#t~malloc0.base| 0) 
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 1) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 1)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 1) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 1)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset (- 1)) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 1)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 1)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 1)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base (- 1)) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 1) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset (- 1)) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0)
 (* |honda_f_#in~x| (- 1)) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 1) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base (- 1)) 
 (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| (- 1))
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 1)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| (- 1))
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| (- 1))
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 1) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset (- 1)) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 1) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| (- 1))
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset (- 1)) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 1) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| (- 1))
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y (- 1)) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 1) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 1)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1)) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 1)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x (- 1))
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 1) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| (- 1))
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_f_#t~mem12| 0) 
 (* honda_f_~c~2.base 0) (* |honda_f_#t~malloc0.offset| 0)
 (* |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~mem10| 0) 
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~y_ref~2.offset 0) 
 (* honda_f_~flag~2.base 0) 
 (* |honda_(select #length f_~flag~2.base)| 0)
 (* |honda_(ite (select #valid f_~c~2.base) 1 0)| 0)
 (* |honda_(select #length f_~y_ref~2.base)| 0)
 (* |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)| 0)
 (* honda_f_~y 0) (* honda_f_~x 0)
 (* |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_#NULL.offset| 0)
 (*
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select #length f_~c~2.base)| 0) 
 (* |honda_f_#t~malloc1.offset| 0)
 (* |honda_(ite (select #valid f_~y_ref~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0) (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) f_~c~2.base) 1 0)| 0)
 (* |honda_f_#in~y| 0) (* |honda_f_#t~malloc0.base| 0)
 (* honda_f_~y_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select old(#length) f_~y_ref~2.base)| 0) 
 (* |honda_f_#in~x| 0) (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(select #length f_~x_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0) 
 (* honda_f_~flag~2.offset 0) 
 (* honda_f_~x_ref~2.base 0)
 (* |honda_(ite (select #valid f_~x_ref~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_(select old(#length) f_~x_ref~2.base)| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_(select old(#length) f_~flag~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 0) (* |honda_(ite (select #valid f_~flag~2.base) 1 0)| 0)
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~malloc1.base| 0) 
 (* honda_f_~x_ref~2.offset 0) 
 (* honda_f_~c~2.offset 0) 
 (* |honda_f_#t~mem8| 0) (* |honda_(select old(#length) f_~c~2.base)| 0)
 (* |init_f_#in~y| 0) (* init_f_~c~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~y_ref~2.base 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* |init_f_#in~x| 0) (* |init_f_#t~malloc3.offset| 0)
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~y_ref~2.offset 0) 
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~flag~2.offset 0) 
 (* init_f_~x_ref~2.base 0) 
 (* init_f_~flag~2.base 0) 
 (* init_f_~y 0) (* |init_f_#t~malloc2.base| 0) 
 (* init_f_~x 0) (* |init_#NULL.offset| 0) 
 (* init_f_~x_ref~2.offset 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* init_f_~c~2.offset 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)))
 (or
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) (- 1))
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 1)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 (- 1)) (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0)
 (* (* ray_f_~flag~2.base lambda) (- 1))
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 1)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and (= honda_f_~c~2.base (+ honda_f_~c~2.base ray_f_~c~2.base))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~y_ref~2.offset
 (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset))
 (= honda_f_~flag~2.base (+ honda_f_~flag~2.base ray_f_~flag~2.base))
 (= |honda_(select #length f_~flag~2.base)|
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|))
 (= |honda_(ite (select #valid f_~c~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|))
 (= |honda_(select #length f_~y_ref~2.base)|
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|))
 (= |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|))
 (= honda_f_~y (+ honda_f_~y ray_f_~y))
 (= honda_f_~x (+ honda_f_~x ray_f_~x))
 (= |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (=
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select #length f_~c~2.base)|
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|))
 (= |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|))
 (= |honda_f_#in~y| (+ |honda_f_#in~y| |ray_f_#in~y|))
 (= honda_f_~y_ref~2.base (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_(select old(#length) f_~y_ref~2.base)|
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|))
 (= |honda_f_#in~x| (+ |honda_f_#in~x| |ray_f_#in~x|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(select #length f_~x_ref~2.base)|
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= honda_f_~flag~2.offset (+ honda_f_~flag~2.offset ray_f_~flag~2.offset))
 (= honda_f_~x_ref~2.base (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base))
 (= |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_(select old(#length) f_~x_ref~2.base)|
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|))
 (= |honda_(select old(#length) f_~flag~2.base)|
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|))
 (=
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|))
 (= |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|))
 (= honda_f_~x_ref~2.offset
 (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~c~2.offset (+ honda_f_~c~2.offset ray_f_~c~2.offset))
 (= |honda_(select old(#length) f_~c~2.base)|
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|))
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 1)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 1)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) (- 1))
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 1)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 1)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 1)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|)
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 1)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 1)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) (- 1))
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 1)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 1)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) (- 1))
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (>=
 (+ (* (+ |honda_f_#t~mem12| |ray_f_#t~mem12|) 0)
 (* (+ honda_f_~c~2.base ray_f_~c~2.base) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~mem10| |ray_f_#t~mem10|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~y_ref~2.offset ray_f_~y_ref~2.offset) 0)
 (* (+ honda_f_~flag~2.base ray_f_~flag~2.base) 0)
 (*
 (+ |honda_(select #length f_~flag~2.base)|
 |ray_(select #length f_~flag~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~c~2.base) 1 0)|
 |ray_(ite (select #valid f_~c~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length f_~y_ref~2.base)|
 |ray_(select #length f_~y_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|) 0)
 (* (+ honda_f_~y ray_f_~y) 0) 
 (* (+ honda_f_~x ray_f_~x) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length f_~c~2.base)| |ray_(select #length f_~c~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid f_~y_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~c~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|) 0)
 (* (+ |honda_f_#in~y| |ray_f_#in~y|) 0)
 (* (+ honda_f_~y_ref~2.base ray_f_~y_ref~2.base) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~y_ref~2.base)|
 |ray_(select old(#length) f_~y_ref~2.base)|) 0)
 (* (+ |honda_f_#in~x| |ray_f_#in~x|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(select #length f_~x_ref~2.base)|
 |ray_(select #length f_~x_ref~2.base)|) 1)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (* (+ honda_f_~flag~2.offset ray_f_~flag~2.offset) 0)
 (* (+ honda_f_~x_ref~2.base ray_f_~x_ref~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~x_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|
 |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)|) 0)
 (*
 (+ |honda_(select old(#length) f_~x_ref~2.base)|
 |ray_(select old(#length) f_~x_ref~2.base)|) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (*
 (+ |honda_(select old(#length) f_~flag~2.base)|
 |ray_(select old(#length) f_~flag~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~flag~2.base) 1 0)|
 |ray_(ite (select #valid f_~flag~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~post9| |ray_f_#t~post9|) 0)
 (* (+ honda_f_~x_ref~2.offset ray_f_~x_ref~2.offset) (- 1))
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ honda_f_~c~2.offset ray_f_~c~2.offset) 0)
 (*
 (+ |honda_(select old(#length) f_~c~2.base)|
 |ray_(select old(#length) f_~c~2.base)|) 0)
 (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0) 
 (* |honda_f_#t~mem12| 0) 
 (* |honda_f_#t~mem10| 0)
 (* |honda_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~post9| 0) 
 (* |honda_f_#t~mem8| 0) (- 4)) 0)
 (= ray_f_~c~2.base (* ray_f_~c~2.base lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~y_ref~2.offset (* ray_f_~y_ref~2.offset lambda))
 (= ray_f_~flag~2.base (* ray_f_~flag~2.base lambda))
 (= |ray_(select #length f_~flag~2.base)|
 (* |ray_(select #length f_~flag~2.base)| lambda))
 (= |ray_(ite (select #valid f_~c~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda))
 (= |ray_(select #length f_~y_ref~2.base)|
 (* |ray_(select #length f_~y_ref~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda)) (= ray_f_~y (* ray_f_~y lambda)) 
 (= ray_f_~x (* ray_f_~x lambda))
 (= |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select #length f_~c~2.base)|
 (* |ray_(select #length f_~c~2.base)| lambda))
 (= |ray_(ite (select #valid f_~y_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) f_~c~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda))
 (= |ray_f_#in~y| (* |ray_f_#in~y| lambda))
 (= ray_f_~y_ref~2.base (* ray_f_~y_ref~2.base lambda))
 (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) f_~y_ref~2.base)|
 (* |ray_(select old(#length) f_~y_ref~2.base)| lambda))
 (= |ray_f_#in~x| (* |ray_f_#in~x| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(select #length f_~x_ref~2.base)|
 (* |ray_(select #length f_~x_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= ray_f_~flag~2.offset (* ray_f_~flag~2.offset lambda))
 (= ray_f_~x_ref~2.base (* ray_f_~x_ref~2.base lambda))
 (= |ray_(ite (select #valid f_~x_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_(select old(#length) f_~x_ref~2.base)|
 (* |ray_(select old(#length) f_~x_ref~2.base)| lambda))
 (= |ray_(select old(#length) f_~flag~2.base)|
 (* |ray_(select old(#length) f_~flag~2.base)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda))
 (= |ray_(ite (select #valid f_~flag~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda))
 (= ray_f_~x_ref~2.offset (* ray_f_~x_ref~2.offset lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~c~2.offset (* ray_f_~c~2.offset lambda))
 (= |ray_(select old(#length) f_~c~2.base)|
 (* |ray_(select old(#length) f_~c~2.base)| lambda))
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 1)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 (- 1)) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 1)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0)
 (* (* ray_f_~c~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) (- 1))
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 1) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 1) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| (- 1))
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 1) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 1)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0)
 (* (* ray_f_~x_ref~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 1) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) (- 1)) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 1)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) (- 1))
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 1) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) (- 1))
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_f_#t~mem12| lambda) 0) 
 (* (* ray_f_~c~2.base lambda) 0) 
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~mem10| lambda) 0) 
 (* (* |ray_f_#t~malloc3.offset| lambda) 0)
 (* (* ray_f_~y_ref~2.offset lambda) 0) 
 (* (* ray_f_~flag~2.base lambda) 0)
 (* (* |ray_(select #length f_~flag~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length f_~y_ref~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~c~2.base) f_~c~2.offset)|
 lambda) 0) (* (* ray_f_~y lambda) 0) 
 (* (* ray_f_~x lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~flag~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length f_~c~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~y_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~c~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#in~y| lambda) 0) 
 (* (* ray_f_~y_ref~2.base lambda) 0)
 (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)|
 lambda) 0) (* (* |ray_(select old(#length) f_~y_ref~2.base)| lambda) 0)
 (* (* |ray_f_#in~x| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(select #length f_~x_ref~2.base)| lambda) 1)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* ray_f_~flag~2.offset lambda) 0) 
 (* (* ray_f_~x_ref~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~x_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| lambda)
 0) (* (* |ray_(select old(#length) f_~x_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem14| lambda) 0)
 (* (* |ray_(select old(#length) f_~flag~2.base)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~y_ref~2.base) f_~y_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid f_~flag~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~post9| lambda) 0) 
 (* (* ray_f_~x_ref~2.offset lambda) (- 1))
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* ray_f_~c~2.offset lambda) 0)
 (* (* |ray_(select old(#length) f_~c~2.base)| lambda) 0)
 (* (* |ray_f_#t~mem8| lambda) 0) 
 (* |ray_f_#t~mem12| 0) (* |ray_f_#t~mem10| 0)
 (* |ray_(select (select #memory_int f_~y_ref~2.base) f_~y_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~x_ref~2.base) f_~x_ref~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~flag~2.base) f_~flag~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~c~2.base) f_~c~2.offset)| 0)
 (* |ray_f_#t~mem14| 0) (* |ray_f_#t~post9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

